//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2011)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org

#include "gui2Frm.h"
#include "get_proj.h"
#include <iostream>
#include <fstream>
#include <string>
#include <wx/wx.h>

using namespace std;

void projectFileAnalysis::analyzeProjectFileContent(string fileContent)
{
  long counter1=0, counter_token=0;
  char *token;
  char *temp_total_chars;
  
  const char *total_chars=fileContent.c_str();
  temp_total_chars = (char*)total_chars;
  
  token = strtok((char*)temp_total_chars,"\n");
  intNumPer=atoi(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  intITMUnits=atoi(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  intLengthUnits=atoi(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  intNumLayers=atoi(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  intNumRows=atoi(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  intNumCols=atoi(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  lngIntNumStep=new long[intNumPer];
  
  for(counter1=0;counter1<intNumPer;counter1++)
  {
    token = strtok((char*)temp_total_chars,"\n");
    lngIntNumStep[counter1]=atoi(token);
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
  }
  
  token = strtok((char*)temp_total_chars,"\n");
  intTimeStepMulti=atoi(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  intSavePeriods=atoi(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  dblPerLen=atof(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  dblTimeUnitMult=atof(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  dblLengthUnitMult=atof(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  dblXRasterDistance=atof(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  dblYRasterDistance=atof(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  dblRechMult=atof(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  dblDisMult=atof(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  dblXRasterMin=atof(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  dblYRasterMin=atof(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  strPathProjectFile=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  strPathProjectFilePre=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  strPathProjectFilePost=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  strPathProjectFileEx=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  strLayerType=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  strLayerAverage=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  strChani=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  strVerticalK=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  strWetting=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  intConstantHKValueFlag=new int[intNumLayers];
  intConstantVKValueFlag=new int[intNumLayers];
  intConstantSSValueFlag=new int[intNumLayers];
  
  dblConstantHKValue=new double[intNumLayers];
  dblConstantVKValue=new double[intNumLayers];
  dblConstantSSValue=new double[intNumLayers];
 
  for(counter1=0;counter1<intNumLayers-1;counter1++)
  {
    token = strtok((char*)temp_total_chars,"\n");
    intConstantHKValueFlag[counter1]=atoi(token);
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token; 
    
    token = strtok((char*)temp_total_chars,"\n");
    intConstantVKValueFlag[counter1]=atoi(token);
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
    
    token = strtok((char*)temp_total_chars,"\n");
    intConstantSSValueFlag[counter1]=atoi(token);
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
    
    token = strtok((char*)temp_total_chars,"\n");
    dblConstantHKValue[counter1]=atof(token);
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
    
    token = strtok((char*)temp_total_chars,"\n");
    dblConstantVKValue[counter1]=atof(token);
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
    
    token = strtok((char*)temp_total_chars,"\n");
    dblConstantSSValue[counter1]=atof(token);
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
  }
  
  token = strtok((char*)temp_total_chars,"\n");
  intPntPSlice=atoi(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  intConstantRechValueFlag=new int[intNumPer];
  dblConstantRechValue=new double[intNumPer];
  
  for(counter1=0;counter1<intNumPer; counter1++)
  {
    token = strtok((char*)temp_total_chars,"\n");
    intConstantRechValueFlag[counter1]=atoi(token);
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
  
    token = strtok((char*)temp_total_chars,"\n");
    dblConstantRechValue[counter1]=atof(token);
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
  }
  
  token = strtok((char*)temp_total_chars,"\n");
  intOCSaveAllLayers=atoi(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  intOCSaveAllPeriods=atoi(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  intOCSaveLayer=atoi(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  intOCSavePeriod=atoi(token);
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  strProjName=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  dblStressPLength = new double[intNumPer];
  dblTimeStepLength = new double[intNumPer];
  intTimeMode=new int[intNumPer];
  
  for(counter1=0;counter1<intNumPer; counter1++)
  {
    token = strtok((char*)temp_total_chars,"\n");
    dblStressPLength[counter1]=atof(token);
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
  
    token = strtok((char*)temp_total_chars,"\n");
    dblTimeStepLength[counter1]=atof(token);
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
    
    token = strtok((char*)temp_total_chars,"\n");
    intTimeMode[counter1]=atoi(token);
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
  }
  
  //data for dialogs
  
  token = strtok((char*)temp_total_chars,"\n");
  strTopLayer=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  strLayerBot= new wxString[intNumLayers];
  strLayerHCond= new wxString[intNumLayers];
  strLayerVCond= new wxString[intNumLayers];
  strLayerSpecStor= new wxString[intNumLayers];
  strLayerBC= new wxString[intNumLayers];
  strLayerIH= new wxString[intNumLayers];
  
  for(counter1=0;counter1<intNumLayers-1; counter1++)
  {
    token = strtok((char*)temp_total_chars,"\n");
    strLayerBot[counter1]=token;
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
    
    token = strtok((char*)temp_total_chars,"\n");
    strLayerHCond[counter1]=token;
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
    
    token = strtok((char*)temp_total_chars,"\n");
    strLayerVCond[counter1]=token;
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
    
    token = strtok((char*)temp_total_chars,"\n");
    strLayerSpecStor[counter1]=token;
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
    
    token = strtok((char*)temp_total_chars,"\n");
    strLayerBC[counter1]=token;
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
    
    token = strtok((char*)temp_total_chars,"\n");
    strLayerIH[counter1]=token;
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
  }
  
  strStreePeriod= new wxString[intNumPer];
  dblTimeStepLength2=new double[intNumPer];
  intTimeMode2=new int[intNumPer];
  strRech= new wxString[intNumPer];
  strWells= new wxString[intNumPer];
  
  for(counter1=0;counter1<intNumPer; counter1++)
  {
    token = strtok((char*)temp_total_chars,"\n");
    strStreePeriod[counter1]=token;
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
    
    token = strtok((char*)temp_total_chars,"\n");
    dblTimeStepLength2[counter1]=atof(token);
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
    
    token = strtok((char*)temp_total_chars,"\n");
    intTimeMode2[counter1]=atoi(token);
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
    
    token = strtok((char*)temp_total_chars,"\n");
    strRech[counter1]=token;
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;
    
    token = strtok((char*)temp_total_chars,"\n");
    strWells[counter1]=token;
    counter_token=strlen(token)+1;
    temp_total_chars=temp_total_chars+counter_token;

  }
  
  token = strtok((char*)temp_total_chars,"\n");
  strSaveResLay=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  strSaveResStrePer=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  strOuterIter=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  strInnerIter=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  strHeadChangeCrit=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
  token = strtok((char*)temp_total_chars,"\n");
  strResCrit=token;
  counter_token=strlen(token)+1;
  temp_total_chars=temp_total_chars+counter_token;
  
/*  
  
    for(counter=0;counter<intNPER;counter++)
  {
    strSaveString<<intConstantRechValueFlag[counter]<<"\n";
    strSaveString<<dblConstantRechValue[counter]<<"\n";
  }
  
  
  
    for(counter=0;counter<intNPER;counter++)
  {
    strSaveString<<vStressPeriodLength[counter]<<"\n";
    strSaveString<<vTimeStepLength[counter]<<"\n";
    strSaveString<<vTimeMode[counter]<<"\n";
  }
*/

}

void projectFileAnalysis::getIntNSTP(long IntNumStep[])
{
  long counter1, a;
  
  for(counter1=0;counter1<intNumPer;counter1++)
  {
    IntNumStep[counter1]=lngIntNumStep[counter1];
    
  }
}

void projectFileAnalysis::getConductivityFlags(int ConstantHKValueFlag[], int ConstantVKValueFlag[], int ConstantSSValueFlag[])
{
  long counter1;
  
  for(counter1=0;counter1<intNumLayers;counter1++)
  {
    ConstantHKValueFlag[counter1]=intConstantHKValueFlag[counter1];
    ConstantVKValueFlag[counter1]=intConstantVKValueFlag[counter1];
    ConstantSSValueFlag[counter1]=intConstantSSValueFlag[counter1];
  }
}

void projectFileAnalysis::getConductivityValues(double ConstantHKValue[], double ConstantVKValue[], double ConstantSSValue[])
{
  long counter1;
  
  for(counter1=0;counter1<intNumLayers;counter1++)
  {
    ConstantHKValue[counter1]=dblConstantHKValue[counter1];
    ConstantVKValue[counter1]=dblConstantVKValue[counter1];
    ConstantSSValue[counter1]=dblConstantSSValue[counter1];
  }
}

void projectFileAnalysis::getConstRecharge(int ConstRechFlag[], double ConstRechValue[])
{
  long counter1;
  
  for(counter1=0;counter1<intNumPer;counter1++)
  {
    ConstRechFlag[counter1]=intConstantRechValueFlag[counter1];
    ConstRechValue[counter1]=dblConstantRechValue[counter1];
  }
}

//void projectFileAnalysis::getOCSaveLayersPeriods(wxString strOCSaveSingleLayers, wxString strOCSaveSinglePeriods)
//{
//  long counter1;
  
//  for(counter1=0;counter1<intNumPer;counter1++)
//  {
//    IntNumStep[counter1]=lngIntNumStep[counter1];
//  }
//}

void projectFileAnalysis::getStressPeriodData(double StressPLength[], double TimeStepLength[], int TimeMode[])
{
  long counter1;
  
  for(counter1=0;counter1<intNumPer;counter1++)
  {
    StressPLength[counter1]=dblStressPLength[counter1];
    TimeStepLength[counter1]=dblTimeStepLength[counter1];
    TimeMode[counter1]=intTimeMode[counter1];
  }
}

void projectFileAnalysis::getLayerParameters(wxString LayerBot[], wxString LayerHCond[], wxString LayerVCond[], wxString LayerSpecStor[], wxString LayerBC[], wxString LayerIH[])
{
  long counter1;
  
  for(counter1=0;counter1<intNumLayers;counter1++)
  {
    LayerBot[counter1]=strLayerBot[counter1];
    LayerHCond[counter1]=strLayerHCond[counter1];
    LayerVCond[counter1]=strLayerVCond[counter1];
    LayerSpecStor[counter1]=strLayerSpecStor[counter1];
    LayerBC[counter1]=strLayerBC[counter1];
    LayerIH[counter1]=strLayerIH[counter1];
  }
}

void projectFileAnalysis::getPeriodParameters(wxString StreePeriod[], double TimeStepLength2[], int TimeMode2[], wxString Rech[], wxString Wells[])
{
  long counter1;
  
  for(counter1=0;counter1<intNumPer;counter1++)
  {
    StreePeriod[counter1]=strStreePeriod[counter1];
    TimeStepLength2[counter1]=dblTimeStepLength2[counter1];
    TimeMode2[counter1]=intTimeMode2[counter1];
    Rech[counter1]=strRech[counter1];
    Wells[counter1]=strWells[counter1];
  }
}