//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2011)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org

#include <iostream>
#include <fstream>
#include <string>
#include <wx/wx.h>
#include <wx/tokenzr.h>
#include "get_well_data.h"

using namespace std;

void getWellData::setFile(char file_load[])
{
       infile=file_load;

}

void getWellData::getPointsFromFile()
{
     ifstream fin(infile);
     getline(fin, file_content,'\t');
     fin.close();
}

void getWellData::analyze_file_content()
{
     char *temp_total_chars; 
     int delimiter='\n';
     long counter=0;
     char *token;
     long counter_token;
     long lngTotalStringLength;
     
     const char *total_chars=file_content.c_str();
     temp_total_chars = (char*)total_chars;
     char *substr=temp_total_chars;
     
     while (substr=strchr(substr,delimiter))
     {
            counter++;
            substr++;
     }
   
     lngTotalStringLength=strlen(temp_total_chars);
     
     lngNumWells=counter;
     
     wxString wxTemStringSE;
     
     x = new double[lngNumWells];
     y = new double[lngNumWells];
     z = new double[lngNumWells];
     discharge = new double[lngNumWells];
     
     
     for (long lngCounterWells=0;lngCounterWells<lngNumWells;lngCounterWells++)
     {
            token = strtok((char*)temp_total_chars," ");
            x[lngCounterWells]=atof(token);
            counter_token=strlen(token)+1;
            temp_total_chars=temp_total_chars+counter_token;
            
            token = strtok((char*)temp_total_chars," ");
            y[lngCounterWells]=atof(token);
            counter_token=strlen(token)+1;
            temp_total_chars=temp_total_chars+counter_token;
            
            token = strtok((char*)temp_total_chars," ");
            z[lngCounterWells]=atof(token);
            counter_token=strlen(token)+1;
            temp_total_chars=temp_total_chars+counter_token;
            
            token = strtok((char*)temp_total_chars,"\n");
            discharge[lngCounterWells]=atof(token);
            counter_token=strlen(token)+1;
            temp_total_chars=temp_total_chars+counter_token;
     }
}

void getWellData::getPoints(double x_value[], double y_value[], double z_value[], double discharge_v[])
{
    long counterPoints;
    
    for (counterPoints=0; counterPoints<lngNumWells;counterPoints++)
    {
        x_value[counterPoints]=x[counterPoints];
        y_value[counterPoints]=y[counterPoints];
        z_value[counterPoints]=z[counterPoints];
        discharge_v[counterPoints]=discharge[counterPoints];
    }
}
