//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2011)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org


#ifndef __GUI2FRM_H__
#define __GUI2FRM_H__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/frame.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/menu.h>
#include <wx/choicdlg.h>
#include <wx/filedlg.h>
#include <wx/textctrl.h>
#include <wx/checkbox.h>
#include <wx/radiobut.h>
#include <wx/radiobox.h>
#include <wx/choice.h>
#include <wx/button.h>
#include <wx/stattext.h>
#include <wx/listbox.h>
#include <wx/panel.h>
#include <wx/notebook.h>
#include <wx/filename.h>
#include <wx/file.h>
////Header Include End

#include <vector>
#include <cctype>

using namespace std;


////Dialog Style Start
#undef gui2Frm_STYLE
#define gui2Frm_STYLE wxCAPTION | wxSYSTEM_MENU | wxMINIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

class gui2Frm : public wxFrame
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		gui2Frm(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("gui2"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = gui2Frm_STYLE);
		virtual ~gui2Frm();
		void WxRadioBox1Click(wxCommandEvent& event);
		void WxRadioSecondsClick(wxCommandEvent& event);
		void WxRadioMinuteClick(wxCommandEvent& event);
		void WxRadioHourClick(wxCommandEvent& event);
		void WxRadioCentimetersClick(wxCommandEvent& event);
		void WxRadioMetersClick(wxCommandEvent& event);
		void WxRadioDayClick(wxCommandEvent& event);
		void Mnuopenproject1030Click(wxCommandEvent& event);
		void Mnusaveproject1031Click(wxCommandEvent& event);
		void Mnuexit1032Click(wxCommandEvent& event);
		void Mnumanual1034Click(wxCommandEvent& event);
		void Mnuhelptopics1034Click(wxCommandEvent& event);
		void Mnumanual1035Click(wxCommandEvent& event);
		void Mnuabout1036Click(wxCommandEvent& event);
		void WxRadioButtonMetersClick(wxCommandEvent& event);
		void WxRadioButtonCentimetersClick(wxCommandEvent& event);
		void Mnusaveprojectas1038Click(wxCommandEvent& event);
		void WxButtonInsertPeriodClick(wxCommandEvent& event);
		void WxButtonInsertLayerBottomClick(wxCommandEvent& event);
		void WxButtonShowStructureClick(wxCommandEvent& event);
		void WxButtonDelLayerBottomsClick(wxCommandEvent& event);
		void WxButtonDelStressPeriodsClick(wxCommandEvent& event);
		void WxButtonSaveDisFileClick(wxCommandEvent& event);
		void WxButtonClearBoundaryCondClick(wxCommandEvent& event);
		void WxButtonClearInitialHeadsClick(wxCommandEvent& event);
		void WxButtonInsertBoundaryCondClick(wxCommandEvent& event);
		void WxButtonSaveBoundaryCondInitialHeadsClick(wxCommandEvent& event);
		void WxButtonInsertInitialHeadsClick(wxCommandEvent& event);
		void WxButtonInsertHorConductClick(wxCommandEvent& event);
		void WxButtonInsertVertConductClick(wxCommandEvent& event);
		void WxButtonInsertSpecStorageClick(wxCommandEvent& event);
		void WxButtonDelHorConductClick(wxCommandEvent& event);
		void WxButtonDelVertConductClick(wxCommandEvent& event);
		void WxButtonDelSpecStorageClick(wxCommandEvent& event);
		void WxButtonSaveParametersModflowClick(wxCommandEvent& event);
		void WxRadioButtonAverArithLogClick(wxCommandEvent& event);
		void WxRadioButtonAverLogClick(wxCommandEvent& event);
		void WxRadioButtonHarmonicMeanClick(wxCommandEvent& event);
		void WxRadioButtonVertValuesClick(wxCommandEvent& event);
		void WxRadioButtonRatioHVClick(wxCommandEvent& event);
		void WxButtonRechInsertClick(wxCommandEvent& event);
		void WxButtonRechClearClick(wxCommandEvent& event);
		void WxButtonWellsDeleteClick(wxCommandEvent& event);
		void Mnunewproject1119Click(wxCommandEvent& event);
		void WxButtonRechWellsSaveModflowClick(wxCommandEvent& event);
		void WxButtonWellsInsertClick(wxCommandEvent& event);
		void WxButtonSaveRunModflowClick(wxCommandEvent& event);
		void WxButtonSaveOutputControlClick(wxCommandEvent& event);
		void WxCheckBoxSaveResAllStressPeriodsClick(wxCommandEvent& event);
		void WxCheckBoxSaveResAllLayersClick(wxCommandEvent& event);
		void WxListBoxSaveResStressPeriodsSelected(wxCommandEvent& event);
		void WxListBoxSaveResLayersSelected(wxCommandEvent& event);
		void WxButtonAddSavePeriodClick(wxCommandEvent& event);
		void WxButtonAddSaveLayerClick(wxCommandEvent& event);
		void WxButtonTransferToGISClick(wxCommandEvent& event);
		
	private:
		//Do not add custom control declarations between
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxFileDialog *WxOpenFileDialogBoundaryCond;
		wxFileDialog *WxOpenProjFileDialog;
		wxFileDialog *WxSaveProjFileDialog;
		wxFileDialog *WxSaveAsProjFileDialog;
		wxMenuBar *WxMenuBarTop;
		wxMultiChoiceDialog *WxMultiChoiceDialogAddSavePeriodsLayers;
		wxFileDialog *WxOpenFileDialogInitialHeads;
		wxFileDialog *WxOpenFileDialogBottoms;
		wxPanel *WxNoteBookObs;
		wxPanel *WxNoteBookSolver;
		wxPanel *WxNoteBookModpath;
		wxButton *WxButtonTransferToGIS;
		wxButton *WxButtonSaveRunModflow;
		wxTextCtrl *WxEditResidualCrit;
		wxTextCtrl *WxEditHeadChangeCrit;
		wxTextCtrl *WxEditInnerIterations;
		wxTextCtrl *WxEditOuterIter;
		wxStaticText *WxStaticTextResidualCriterionUnit;
		wxStaticText *WxStaticTextResidualCriterion;
		wxStaticText *WxStaticTextHeadChangeM;
		wxStaticText *WxStaticTextHeadChange;
		wxStaticText *WxStaticTextInnerIterations;
		wxStaticText *WxStaticTextOuterIterations;
		wxPanel *WxNoteBookP_Ex;
		wxButton *WxButtonAddSaveLayer;
		wxButton *WxButtonAddSavePeriod;
		wxButton *WxButtonSaveOutputControl;
		wxCheckBox *WxCheckBoxSaveResAllLayers;
		wxListBox *WxListBoxSaveResLayers;
		wxStaticText *WxStaticTextSaveResLayers;
		wxCheckBox *WxCheckBoxSaveResAllStressPeriods;
		wxListBox *WxListBoxSaveResStressPeriods;
		wxStaticText *WxStaticTextSaveResPeriods;
		wxPanel *WxNoteBookoC;
		wxStaticText *WxStaticTextDischargeUnits;
		wxStaticText *WxStaticTextRechUnits;
		wxButton *WxButtonRechWellsSaveModflow;
		wxStaticText *WxStaticTextWellsEnd;
		wxStaticText *WxStaticTextWellsStart;
		wxChoice *WxChoiceDischargUnits;
		wxButton *WxButtonWellsDelete;
		wxButton *WxButtonWellsInsert;
		wxListBox *WxListBoxWells;
		wxStaticText *WxStaticTextWellsCaption;
		wxStaticText *WxStaticTextRechargeCaption;
		wxStaticText *WxStaticTextRechEnd;
		wxStaticText *WxStaticTextRechStart;
		wxButton *WxButtonRechClear;
		wxListBox *WxListBoxRech;
		wxChoice *WxChoiceRechUnits;
		wxButton *WxButtonRechInsert;
		wxStaticText *WxStaticTextRechWellNUmStressPeriods;
		wxStaticText *WxStaticTextRechWellsStressPeriodInfo;
		wxPanel *WxNoteBookZB;
		wxStaticText *WxStaticTextInfoNumLayersCount;
		wxStaticText *WxStaticTextInfoUnmLayers;
		wxStaticText *WxStaticTextBottomInitialHeads;
		wxStaticText *WxStaticTextTopInitialHeads;
		wxButton *WxButtonSaveBoundaryCondInitialHeads;
		wxButton *WxButtonClearInitialHeads;
		wxButton *WxButtonInsertInitialHeads;
		wxListBox *WxListBoxInitialHeads;
		wxStaticText *WxStaticTextInitialHead;
		wxStaticText *WxStaticTextBoundariesBoundaryCond;
		wxStaticText *WxStaticTextBottomBoundaryCond;
		wxStaticText *WxStaticTextTopBoundaryCond;
		wxButton *WxButtonClearBoundaryCond;
		wxButton *WxButtonInsertBoundaryCond;
		wxListBox *WxListBoxBoundaryCond;
		wxPanel *WxNoteBookBC;
		wxStaticText *WxStaticTextParamInfoNumLayers2;
		wxStaticText *WxStaticTextParamInfoNumLayers;
		wxRadioButton *WxRadioButtonVertValues;
		wxRadioButton *WxRadioButtonRatioHV;
		wxRadioBox *WxRadioBox1;
		wxRadioButton *WxRadioButtonAverArithLog;
		wxRadioButton *WxRadioButtonAverLog;
		wxRadioButton *WxRadioButtonHarmonicMean;
		wxRadioBox *WxRadioBoxAverKValues;
		wxButton *WxButtonDelSpecStorage;
		wxButton *WxButtonDelVertConduct;
		wxButton *WxButtonDelHorConduct;
		wxButton *WxButtonSaveParametersModflow;
		wxButton *WxButtonInsertSpecStorage;
		wxButton *WxButtonInsertVertConduct;
		wxListBox *WxListBoxSpecStorage;
		wxListBox *WxListBoxVertConduct;
		wxStaticText *WxStaticTextSpecificStorage;
		wxStaticText *WxStaticTextVertConduct;
		wxStaticText *WxStaticTextHorConduct;
		wxButton *WxButtonInsertHorConduct;
		wxListBox *WxListBoxHorConduct;
		wxPanel *WxNoteBookParameters;
		wxChoice *WxChoiceTimeUnits;
		wxStaticText *WxStaticTextTimeUnits;
		wxStaticText *WxStaticTextLengthUnits;
		wxChoice *WxChoiceLengthUnit;
		wxButton *WxButtonDelStressPeriods;
		wxButton *WxButtonDelLayerBottoms;
		wxButton *WxButtonShowStructure;
		wxButton *WxButtonSaveDisFile;
		wxButton *WxButtonInsertPeriod;
		wxButton *WxButtonInsertLayerBottom;
		wxListBox *WxListBoxStressPeriods;
		wxStaticText *WxStaticTextPeriodsDefEnd;
		wxStaticText *WxStaticTextEriodsDefStart;
		wxStaticText *WxStaticTextTimeDiscret;
		wxStaticText *WxStaticTextSpatialDiscret;
		wxStaticText *WxStaticTextBottomLayersBottom;
		wxStaticText *WxStaticTextTopLayerBottoms;
		wxListBox *WxListBoxNamesLayerBot;
		wxPanel *WxNoteBookDiscretization;
		wxNotebook *WxNotebookInput;
		////GUI Control Declaration End
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_MNU_FILE_1029 = 1029,
			ID_MNU_NEWPROJECT_1119 = 1119,
			ID_MNU_OPENPROJECT_1030 = 1030,
			ID_MNU_SAVEPROJECT_1031 = 1031,
			ID_MNU_SAVEPROJECTAS_1038 = 1038,
			ID_MNU_EXIT_1032 = 1032,
			ID_MNU_HELP_1033 = 1033,
			ID_MNU_HELPTOPICS_1034 = 1034,
			ID_MNU_MANUAL_1035 = 1035,
			ID_MNU_ABOUT_1036 = 1036,
			
			ID_WXNOTEBOOKOBS = 1009,
			ID_WXNOTEBOOKSOLVER = 1008,
			ID_WXNOTEBOOKMODPATH = 1007,
			ID_WXBUTTONTRANSFERTOGIS = 1143,
			ID_WXBUTTONSAVERUNMODFLOW = 1130,
			ID_WXEDITRESIDUALCRIT = 1129,
			ID_WXEDITHEADCHANGECRIT = 1128,
			ID_WXEDITINNERITERATIONS = 1127,
			ID_WXEDITOUTERITER = 1126,
			ID_WXSTATICTEXTRESIDUALCRITERIONUNIT = 1125,
			ID_WXSTATICTEXTRESIDUALCRITERION = 1124,
			ID_WXSTATICTEXTHEADCHANGEM = 1123,
			ID_WXSTATICTEXTHEADCHANGE = 1122,
			ID_WXSTATICTEXTINNERITERATIONS = 1121,
			ID_WXSTATICTEXTOUTERITERATIONS = 1120,
			ID_WXNOTEBOOKP_EX = 1010,
			ID_WXBUTTONADDSAVELAYER = 1142,
			ID_WXBUTTONADDSAVEPERIOD = 1141,
			ID_WXBUTTONSAVEOUTPUTCONTROL = 1137,
			ID_WXCHECKBOXSAVERESALLLAYERS = 1136,
			ID_WXLISTBOXSAVERESLAYERS = 1135,
			ID_WXSTATICTEXTSAVERESLAYERS = 1134,
			ID_WXCHECKBOXSAVERESALLSTRESSPERIODS = 1133,
			ID_WXLISTBOXSAVERESSTRESSPERIODS = 1132,
			ID_WXSTATICTEXTSAVERESPERIODS = 1131,
			ID_WXNOTEBOOKOC = 1011,
			ID_WXSTATICTEXTDISCHARGEUNITS = 1118,
			ID_WXSTATICTEXTRECHUNITS = 1117,
			ID_WXBUTTONRECHWELLSSAVEMODFLOW = 1116,
			ID_WXSTATICTEXTWELLSEND = 1115,
			ID_WXSTATICTEXTWELLSSTART = 1114,
			ID_WXCHOICEDISCHARGUNITS = 1113,
			ID_WXBUTTONWELLSDELETE = 1112,
			ID_WXBUTTONWELLSINSERT = 1111,
			ID_WXLISTBOXWELLS = 1110,
			ID_WXSTATICTEXTWELLSCAPTION = 1109,
			ID_WXSTATICTEXTRECHARGECAPTION = 1108,
			ID_WXSTATICTEXTRECHEND = 1107,
			ID_WXSTATICTEXTRECHSTART = 1106,
			ID_WXBUTTONRECHCLEAR = 1105,
			ID_WXLISTBOXRECH = 1104,
			ID_WXCHOICERECHUNITS = 1103,
			ID_WXBUTTONRECHINSERT = 1102,
			ID_WXSTATICTEXTRECHWELLNUMSTRESSPERIODS = 1101,
			ID_WXSTATICTEXTRECHWELLSSTRESSPERIODINFO = 1100,
			ID_WXNOTEBOOKZB = 1006,
			ID_WXSTATICTEXTINFONUMLAYERSCOUNT = 1070,
			ID_WXSTATICTEXTINFOUNMLAYERS = 1069,
			ID_WXSTATICTEXTBOTTOMINITIALHEADS = 1068,
			ID_WXSTATICTEXTTOPINITIALHEADS = 1067,
			ID_WXBUTTONSAVEBOUNDARYCONDINITIALHEADS = 1066,
			ID_WXBUTTONCLEARINITIALHEADS = 1065,
			ID_WXBUTTONINSERTINITIALHEADS = 1064,
			ID_WXLISTBOXINITIALHEADS = 1063,
			ID_WXSTATICTEXTINITIALHEAD = 1062,
			ID_WXSTATICTEXTBOUNDARIESBOUNDARYCOND = 1061,
			ID_WXSTATICTEXTBOTTOMBOUNDARYCOND = 1060,
			ID_WXSTATICTEXTTOPBOUNDARYCOND = 1059,
			ID_WXBUTTONCLEARBOUNDARYCOND = 1058,
			ID_WXBUTTONINSERTBOUNDARYCOND = 1057,
			ID_WXLISTBOXBOUNDARYCOND = 1056,
			ID_WXNOTEBOOKBC = 1005,
			ID_WXSTATICTEXTPARAMINFONUMLAYERS2 = 1099,
			ID_WXSTATICTEXTPARAMINFONUMLAYERS = 1098,
			ID_WXRADIOBUTTONVERTVALUES = 1097,
			ID_WXRADIOBUTTONRATIOHV = 1096,
			ID_WXRADIOBOX1 = 1095,
			ID_WXRADIOBUTTONAVERARITHLOG = 1093,
			ID_WXRADIOBUTTONAVERLOG = 1092,
			ID_WXRADIOBUTTONHARMONICMEAN = 1091,
			ID_WXRADIOBOXAVERKVALUES = 1090,
			ID_WXBUTTONDELSPECSTORAGE = 1083,
			ID_WXBUTTONDELVERTCONDUCT = 1082,
			ID_WXBUTTONDELHORCONDUCT = 1081,
			ID_WXBUTTONSAVEPARAMETERSMODFLOW = 1080,
			ID_WXBUTTONINSERTSPECSTORAGE = 1079,
			ID_WXBUTTONINSERTVERTCONDUCT = 1078,
			ID_WXLISTBOXSPECSTORAGE = 1077,
			ID_WXLISTBOXVERTCONDUCT = 1076,
			ID_WXSTATICTEXTSPECIFICSTORAGE = 1075,
			ID_WXSTATICTEXTVERTCONDUCT = 1074,
			ID_WXSTATICTEXTHORCONDUCT = 1073,
			ID_WXBUTTONINSERTHORCONDUCT = 1072,
			ID_WXLISTBOXHORCONDUCT = 1071,
			ID_WXNOTEBOOKPARAMETERS = 1004,
			ID_WXCHOICETIMEUNITS = 1055,
			ID_WXSTATICTEXTTIMEUNITS = 1054,
			ID_WXSTATICTEXTLENGTHUNITS = 1053,
			ID_WXCHOICELENGTHUNIT = 1052,
			ID_WXBUTTONDELSTRESSPERIODS = 1051,
			ID_WXBUTTONDELLAYERBOTTOMS = 1050,
			ID_WXBUTTONSHOWSTRUCTURE = 1049,
			ID_WXBUTTONSAVEDISFILE = 1048,
			ID_WXBUTTONINSERTPERIOD = 1047,
			ID_WXBUTTONINSERTLAYERBOTTOM = 1046,
			ID_WXLISTBOXSTRESSPERIODS = 1045,
			ID_WXSTATICTEXTPERIODSDEFEND = 1044,
			ID_WXSTATICTEXTERIODSDEFSTART = 1043,
			ID_WXSTATICTEXTTIMEDISCRET = 1042,
			ID_WXSTATICTEXTSPATIALDISCRET = 1041,
			ID_WXSTATICTEXTBOTTOMLAYERSBOTTOM = 1039,
			ID_WXSTATICTEXTTOPLAYERBOTTOMS = 1038,
			ID_WXLISTBOXNAMESLAYERBOT = 1037,
			ID_WXNOTEBOOKDISCRETIZATION = 1003,
			ID_WXNOTEBOOKINPUT = 1001,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
		
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
		long intNPER, intITMUNI, intLENUNI, intNLAY, intNROW, intNCOL, *intNSTP, intTSMULT, intSAVEPERIODS;
		double dblPERLEN, dblTMUNIMULT, dblLENUNIMULT, dblXDist, dblYDist, dblRechargeMult, dblDischargeMult;
		double dblXMin, dblYMin;
		wxString pathProjectFile;
		wxString pathProjectFilePre;
		wxString pathProjectFilePost;
		wxString pathProjectFileEx;
		wxString wxstrLayerType;
		wxString wxstrLayerAverage;
		wxString wxstrChani;
		wxString wxstrVerticalK;
		wxString wxstrWetting;
		int *intConstantHKValueFlag;
		int *intConstantVKValueFlag;
		int *intConstantSSValueFlag;
		double *dblConstantHKValue;
		double *dblConstantVKValue;
		double *dblConstantSSValue;
		long intPointsPerSlice;
		int *intConstantRechValueFlag;
		double *dblConstantRechValue;
		long intSaveAllLayers, intSaveAllPeriods, intSaveLayers, intSavePeriods;
		wxString wxstrProjName;
		vector<double> vStressPeriodLength;
		vector<double> vTimeStepLength;
		vector<int> vTimeMode;
};

#endif
