//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2011)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org


#ifndef __PARAMSETTING_H__
#define __PARAMSETTING_H__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/dialog.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/filedlg.h>
#include <wx/listbox.h>
#include <wx/button.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/checkbox.h>
////Header Include End

////Dialog Style Start
#undef paramSetting_STYLE
#define paramSetting_STYLE wxCAPTION | wxSYSTEM_MENU | wxDIALOG_NO_PARENT | wxMINIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

class paramSetting : public wxDialog
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		paramSetting(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("Parameter setting"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = paramSetting_STYLE);
		virtual ~paramSetting();
		void WxButtonParamSettingClick(wxCommandEvent& event);
		void WxButtonParamDistriFileChooseClick(wxCommandEvent& event);

	
	private:
		//Do not add custom control declarations between 
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxFileDialog *WxOpenFileDialogParamFile;
		wxCheckBox *WxCheckBoxLayerConvertible;
		wxCheckBox *WxCheckBoxLayerConfined;
		wxListBox *WxListBoxParamSettingInput;
		wxButton *WxButtonParamSetting;
		wxButton *WxButtonParamDistriFileChoose;
		wxStaticText *WxStaticTextParamConstValue;
		wxStaticText *WxStaticTextParamDistriFile;
		wxTextCtrl *WxEditParamSetConstValue;
		wxCheckBox *WxCheckBoxParamSetConst;
		////GUI Control Declaration End
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_WXCHECKBOXLAYERCONVERTIBLE = 1011,
			ID_WXCHECKBOXLAYERCONFINED = 1010,
			ID_WXLISTBOXPARAMSETTINGINPUT = 1009,
			ID_WXBUTTONPARAMSETTING = 1007,
			ID_WXBUTTONPARAMDISTRIFILECHOOSE = 1005,
			ID_WXSTATICTEXTPARAMCONSTVALUE = 1004,
			ID_WXSTATICTEXTPARAMDISTRIFILE = 1003,
			ID_WXEDITPARAMSETCONSTVALUE = 1002,
			ID_WXCHECKBOXPARAMSETCONST = 1001,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
	
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
		wxString wxstrConstantValue;
		wxString wxstrParamFilePath;
		int intConstantChecked;
		int intLayerTypeVis;
		wxString wxstrLayerType;
		int intValueTextFlag;
		
	public:
		int getConstantValueChecked();
		wxString getConstantValue();
		wxString getParamFilePath(); 
		void setLayerType(int);
		void setTextValue(int);
		void WxCheckBoxLayerConfinedClick(wxCommandEvent& event);
		void WxCheckBoxLayerConvertibleClick(wxCommandEvent& event);
		wxString getLayerType();
};

#endif
